/************************************************
* BT.C: test bit manipulation routines			*
*												*
* 900406 MCMason - Turbo C v2.0					*
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "bitlist.h"

void printBitlist(BitList n)
	{
	int i;
	for (i=1; i<80; i++)
		{
		if (blGetBit(n,i))
			fputc('T',stdout);
		else if (i%10 == 0)
			fputc(i/10+'0',stdout);
		else if (i%5 == 0)
			fputc('+',stdout);
		else
			fputc('-',stdout);
		}
	fputc('\n',stdout);
	}

void main(int argc, char *argv[])
	{
	int i,j;
	BitList a,b,c;

	/* Create the bitlists */
	a=blCreate(80);
	b=blCreate(80);
	c=blCreate(80);
	if ((a==NULL)||(b==NULL)||(c==NULL))
		{
		puts("ERROR: cannot create bitlists!");
		exit(1);
		}

	/* Insert bits specified on command line	*/
	for (i=1; i<argc; i++)
		{
		j=atoi(argv[i]);
		blSetBit(a,j,1);
		}

	/* Print the tablist */
	puts("\nThe bits you set:");
	printBitlist(a);

	/* Copy and invert it */
	blListOp(blCOPY,b,a);
	blListOp(blINVERT,b);
	puts("\nThe inversion of the bits you set:");
	printBitlist(b);
	
	/* Create a random bitlist */
	for (i=0; i<80; i++)
		blSetBit(c,i,(rand()<3276));
	puts("\nA random bitlist:");
	printBitlist(c);

	/* Show the union of the orig & random lists*/
	blListOp(blUNION,c,a);
	puts("\nThe union of your list and the random"
			" bit list is:");
	printBitlist(c);

	/* Show intersection of !orig & random lists*/
	blListOp(blINTERSECT,c,b);
	puts("\nIntersection of your inverted list "
			"and the random list plus your list:");
	printBitlist(c);

	/* Clear a list */
	blListOp(blCLEAR,b);
	puts("\nA cleared bitlist:");
	printBitlist(b);

	/* Set a list */
	blListOp(blSET,b);
	puts("\nA set bitlist:");
	printBitlist(b);

	/* Delete the bitlists */
	blDestroy(a);
	blDestroy(b);
	blDestroy(c);
	}
