/************************************************
* TABTEST.C - test the entab & detab functions	*
*												*
* 900424 MCMason - written for Turbo C v2.0		*
************************************************/

#include <stdio.h>
#include <string.h>
#include "tab.h"

#define TSTSTR "*\t*\t*\t*\t*\t*\t*\t*\t*"
char	in[80], out[80];

/************************************************
* ShowTabs - print string, showing tabs as '\t'	*
*												*
* INP:	s - the string to display				*
************************************************/
void ShowTabs(char *s)
	{
	for ( ; *s; ++s)
		if (*s == '\t')
			fputs("\\t",stdout);
		else
			fputc(*s,stdout);
	}

/************************************************
* ShowTabBar - print a bar, showing the tabstops*
************************************************/
void ShowTabBar(void)
	{
	int i;
	for (i=0; i<80; i++)
		if (isTab(i))	fputc('T',stdout);
		else			fputc('-',stdout);
	}

/************************************************
* main - demonstrate tab expansion/compression	*
* using one of the libraries above.				*
************************************************/
void main(void)
	{
	initTab();		/* initialize tabs, if necc.*/

	printf("TABTEST%c.C - test the tab expansion"
			" and compression functions\nusing "
			"method #%c\n\n",TAB+'0',TAB+'0');

	/* set some tabstops up, if TAB=1, then		*/
	/* only the last one has any effect.		*/
	setTab(50);	setTab(45); setTab(20); setTab(8);
	setTab(35); setTab(30);	setTab(16); setTab(4);

	strcpy(in,TSTSTR);
	detab(in,out);
	fputs("Here is string '",stdout);
	ShowTabs(TSTSTR);
	fputs("' detabbed.\n",stdout);
	ShowTabBar();
	puts(out);

	strcpy(in,"      1       2       3       4  "
			  "          5           6       7");
	puts("\nHere is the string to entab:");
	ShowTabBar();
	puts(in);
	entab(in,out);
	puts("\nHere is the resulting string:");
	ShowTabs(out);
#if TAB==2
	puts("\n\nThe same entabbed string, but "
		 "after removing tabstop #20");
	clrTab(20);
	entab(in,out);
	ShowTabBar();
	ShowTabs(out);
#endif
	}
